package xyz.pixelatedw.finalbeta;

import java.lang.management.ManagementFactory;
import java.time.Duration;
import java.util.HashMap;

import net.minecraft.entity.player.Player;
import net.minecraft.item.ItemInstance;
import net.minecraft.recipe.RecipeRegistry;
import xyz.pixelatedw.finalbeta.mixin.MinecraftAccessorMixin;
import xyz.pixelatedw.finalbeta.mixin.RecipeRegistryAccessorMixin;

public class WyHelper {
	
	public static final String SPAWN_TIME_TAG = "SpawnTime";
	public static final String PLAY_TIME_TAG = "PlayTime";
	public static long playTime;
	
	// Look if they're allowed to hold all block and item data in fucking arrays
	// I am also allowed to abuse maps to extend the shitty metadata excuse
	// doors have ok ? I don't even care about the overhead at this point.
	public static final HashMap<Integer, Long> DOOR_UPDATES = new HashMap<>();
	public static final HashMap<Integer, Boolean> DOOR_STATES = new HashMap<>();
	
	public static void addShapedRecipe(ItemInstance result, Object... recipe) {
		((RecipeRegistryAccessorMixin) RecipeRegistry.getInstance()).invokeAddShapedRecipe(result, recipe);
	}

	public static void addShapelessRecipe(ItemInstance result, Object... ingredients) {
		((RecipeRegistryAccessorMixin) RecipeRegistry.getInstance()).invokeAddShapelessRecipe(result, ingredients);
	}

	public static long getRealDaysPlayed() {
		long seconds = WyHelper.playTime / 20;
		return Duration.ofSeconds(seconds).toDays();
	}

	public static long getGameDaysPlayed() {
		long seconds = MinecraftAccessorMixin.getMinecraft().level.getLevelTime() / 20;
		return Duration.ofSeconds(seconds).toMinutes() / 20;
	}
	
	public static boolean isDebug() {
		return ManagementFactory.getRuntimeMXBean().getInputArguments().toString().indexOf("-agentlib:jdwp") > 0;
	}

	public static float lerp(float delta, float start, float end) {
		return start + delta * (end - start);
	}

	public static float clamp(float val, float min, float max) {
		return val < min ? min : Math.min(val, max);
	}
	
	public static int clamp(int val, int min, int max) {
		return val < min ? min : Math.min(val, max);
	}

	public static void cheatCommand(Player player) {
//		Slime slime = new Slime(player.level);
//		slime.setPositionAndAngles(player.x, player.y + 0.5D, player.z, player.level.rand.nextFloat() * 360.0F, 0.0F);
//		player.level.spawnEntity(slime);
//		slime.setSize(5);

//		player.level.entities.stream().filter(e -> !(e instanceof Player)).forEach((e) -> ((net.minecraft.entity.Entity)e).remove());
		
//		player.dropItem(new ItemInstance(Tile.LADDER, 64));
//		player.dropItem(new ItemInstance(ItemType.minecart, 1));
//		player.dropItem(new ItemInstance(ItemType.minecartFurnace, 1));
//		player.dropItem(new ItemInstance(ItemType.coal, 64));
//		player.dropItem(new ItemInstance(Tile.GOLDEN_RAIL, 64));
//		player.dropItem(new ItemInstance(Tile.COBBLESTONE, 64));

//		player.level.setTile((int)player.x, (int)player.y, (int)player.z, Tile.COBBLESTONE.id);
		
//		int x = 248;
//		int y = 79;
//		int z = -65;
//		
//		for (int i = 0; i < 500; i++) {
//			player.level.setTile(x + i, y, z, Tile.REDSTONE_TORCH_LIT.id);
//		}
		
//		player.level.setLevelTime(0);
//		player.level.getProperties().setRaining(false);
//		player.level.getProperties().setRainTime(0);
//		player.level.getProperties().setThundering(false);
//		player.level.getProperties().setThunderTime(0);
	}
}
